<template>
  <div class="video-container" ref="videoContainer">
    <img
      @click="videoImageClicked()"
      v-if="!showVideo"
      :src="settings.image"
      class="video-img"
      :class="{ 'without-link': !settings.link }"
      :style="imageStyle(settings.opacity, settings.positionTop, settings.positionRight, settings.extraCSS)"
    />
    <div v-else class="holder" ref="holder">
      <youtube
        class="youtube-video"
        :video-id="settings.videoId"
        :player-width="videoWidth"
        :player-height="videoHeight"
        @ready="ready"
      ></youtube>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    settings: {
      type: Object,
    },
  },
  data() {
    return {
      scrollInterval: null,
      showVideo: false,
      scrollInterval: null,
      videoWidth: 300,
      videoHeight: 200
    };
  },
  mounted() {
    var holder = this.$refs["holder"];
    if (!holder) return;
    this.scrollInterval = setInterval(() => {
      if (window.scrollY >= holder.offsetTop + holder.clientHeight) {
        if (this.player) this.player.pauseVideo();
      }
    }, 150);
  },
  beforeDestroy() {
    if (this.scrollInterval) clearInterval(this.scrollInterval);
  },
  methods: {
    imageStyle(opacity=100, positionTop='0px', positionRight='0px', extraCSS={}) {
      return {
        opacity: opacity,
        objectPosition: `calc( 100% - ${positionRight}) ${positionTop}`,
        ...extraCSS
      }
    },
    ready(event) {
      this.player = event.target;
      this.player.playVideo();
    },
    videoClicked() {
      if (this.player) {
        var playerState = this.player.getPlayerState();
        if (playerState == 1) this.player.pauseVideo();
        else this.player.playVideo();
      }
    },
    videoImageClicked() {
      var parent = this.$refs["videoContainer"];
      var parentWidth = parent.clientWidth;
      var parentHeight = parent.clientHeight;
      this.videoWidth = parentWidth;
      this.videoHeight = parentHeight;
      console.log(this.videoWidth, this.videoHeight)
      this.showVideo = true;
    },
  },
};
</script>

<style lang="scss">
.video-container {
  display: flex;
  justify-content: space-between;
  width: 100%;
  height: 100%;

  img {
    width: 100%;
  }

  .video-img {
    cursor: pointer;
    border-radius: 0 1rem 1rem 0;
  }

  .youtube-video {
    width: 100%;
    height: 100%;

    iframe {
      min-height: 100%;
      border-radius: 0 1rem 1rem 0;
    }
  }

  .holder {
    position: relative;
  }

  .overlay {
    width: 100%;
    height: 70%;
    position: absolute;
    color: white;
    opacity: 50%;
    pointer-events: none;
    z-index: 100;
  }
}
</style>